
%  Copyright (c) 2013
%      Noa Fish <noafish@post.tau.ac.il>

function valid = check_geodesic_path(points, normals, src, tgt, path)

thresh1 = 1e-2;
thresh2 = 1e-3;
valid = 1;
prev_dist_valid = 1;
srcp = points(src,:);
tgtp = points(tgt,:);
vec = tgtp - srcp;

pred = path(tgt);

while(pred ~= src)
    
    currp = points(pred,:);
    currn = normals(pred,:);
    vec2 = currp - srcp;
    
    t = dot(vec, vec2) / (norm(vec)^2);
    interp = srcp + t * vec;
    plane_n = currn;
    d = -sum(plane_n .* interp);
    dist = sum(currp .* plane_n) + d;
    
    if(dist < 0)
        if(abs(dist) > thresh1)
            valid = 0;
            break;
        end
        
        if(abs(dist) > thresh2)
            if(~prev_dist_valid)
                valid = 0;
                break;
            end
            prev_dist_valid = 0;
        else
            prev_dist_valid = 1;
        end
        
    else
        prev_dist_valid = 1;
    end
    
    pred = path(pred);
end

end