
%  Copyright (c) 2013
%      Noa Fish <noafish@post.tau.ac.il>

function dists = detect_good_neighbors(dists, sdf_hists)

nump = size(sdf_hists,1);

% if two neighboring patches have the same non-zero bins, then consider
% their histograms as close

for i=1:nump
    for j=i+1:nump
        if(dists(i,j) == Inf)
            continue;
        end
        h1 = sdf_hists(i,:);
        h2 = sdf_hists(j,:);
        nz1 = find(h1 ~= 0);
        nz2 = find(h2 ~= 0);
        intr = intersect(nz1,nz2);
        if(length(nz1) ~= length(nz2) || length(intr) ~= length(nz1))
            continue;
        end
        [sh1, sh1i] = sort(h1,2,'descend');
        [sh2, sh2i] = sort(h2,2,'descend');
        tmp = intersect(sh1i(1:2), sh2i(1:2));
        if(length(tmp) == 2)
            dists(i,j) = 0;
            dists(j,i) = 0;
        end
    end
end

end