
%  Copyright (c) 2013
%      Oliver van Kaick <ovankaic@gmail.com>

function [points, normals] = eliminate_closeby_points(points, normals, thresh)

    mx = -inf;
    for i = 1:size(points, 1)
        dist = sqrt(sum(((repmat(points(i, :), size(points, 1), 1) - points).^2)')');
        mx = max([mx max(dist)]);
    end

    i = 1;
    while i < size(points, 1)
        dist = sqrt(sum(((repmat(points(i, :), size(points, 1), 1) - points).^2)')');
        dist = dist ./ mx;
        sel = find(dist < thresh);
        sel = setdiff(sel, i);
        points(sel, :) = [];
        normals(sel, :) = [];
        i = i + 1;
    end
end
