
%  Copyright (c) 2013
%      Oliver van Kaick <ovankaic@gmail.com>

function dist = get_dist_to_boundary2(points, clusters, gr)

    mp = clusters_to_clustering(clusters);

    dist = inf*ones(length(clusters), size(points, 1));
    bps = [];
    inds = zeros(length(clusters), 2);
    
    for i = 1:length(clusters)
        % Find boundary points
        bp = [];
        for j = 1:length(clusters{i})
            if length(find(mp(gr{clusters{i}(j)}) ~= i)) > 0
                bp(end+1) = clusters{i}(j);
            end
        end
        disp(['    Segment ' num2str(i) ': ' num2str(length(bp)) ' boundary points']);
        drawnow('update');
        
        nump = round(0.2 * length(bp));
        psel = farthest_points(points(bp,:), nump, []);
        bp = bp(psel);
        
        inds(i,:) = [length(bps)+1, length(bps)+length(bp)];
        bps = [bps bp];
        
    end
    
    
    % Get distance from boundary points
        
    [D, ~] = point_shortest_paths(points, gr, bps');
    
    for i=1:length(clusters)
        currD = D(:,inds(i,1):inds(i,2));
        if(isempty(currD))
            dist(i,:) = 1;
            dist(i,clusters{i}) = 0;
            continue;
        end
        sel = (currD > 3.4028e+37);
        currD(sel) = -Inf;
        mx = max(max(currD));
        currD(sel) = mx;
        dist(i,:) = min(dist(i,:), min(currD,[],2)');
        dist(i,:) = map_func(dist(i,:), 0, 1);
    end
end
