
%  Copyright (c) 2013
%      Oliver van Kaick <ovankaic@gmail.com>

%
% Remove small components
%
function new_cc = remove_small_comp(points, gr, cc, th)

    % Get map from points to components
    mp = clusters_to_clustering(cc);

    % Process each component
    for i = 1:length(cc)
        %disp([num2str(i) ' ' num2str(th) ' ' num2str(length(cc{i}))]);
        if length(cc{i}) < th
            n = get_largest_neighbor(points, gr, cc, i, cc{i}, mp);
            if n ~= i
                % Merge components
                cc{n} = [cc{n} cc{i}];
                % Update map
                mp(cc{i}) = n;
                % Clear merged segment
                cc{i} = [];
            end
        end
    end

    % Set output
    new_cc = {};
    for i = 1:length(cc)
        if length(cc{i}) > 0
            new_cc{end+1} = cc{i};
        end
    end
end


function n = get_largest_neighbor(points, gr, cc, indx, comp, mp)

    % Collect all neighbors to this component
    neigh = [];
    for i = 1:length(comp)
        temp = gr{comp(i)};
        neigh = union(neigh, mp(temp));
    end
    neigh = setdiff(neigh, indx);

    % Get neighbors' size
    sz = zeros(length(neigh), 1);
    for i = 1:length(neigh)
        sz(i) = length(cc{neigh(i)});
    end

    [vl, ps] = max(sz);
    n = neigh(ps);
end
