
%  Copyright (c) 2013
%      Noa Fish <noafish@post.tau.ac.il>

%%% update the data structures according to the latest merge of patches


function [patches2, idx2, patch_adj2, patch_adj_c2, ang_hist2, sdf_str2] = merge_and_update(patches, idx, merged, patch_adj_c, ang_hist, sdf_str, info)

patches2 = cell(size(merged));
idx2 = zeros(size(idx));

lookup = zeros(length(patches), 1);
new_neigh = cell(length(merged), 1);

if exist('sdf_str', 'var')
    sdf_str2 = sdf_str;
    sdf_str2.sdf = [];
    sdf_str2.sdf_norm = [];
    sdf_str2.sdf_norm2 = [];
    sdf_str2.flats = [];
    sdf_str2.flats2 = cell(length(merged), 1);
else
    sdf_str2 = [];
end

patches_to_do = [];

for i=1:length(merged)
    m = merged{i};
    lookup(m) = i;
    
    tmp = patches(m);
    patches2{i} = cell2mat(tmp);
    tmp = patch_adj_c(m);
    madj = cell2mat(tmp');
    
    idx2(patches2{i}) = i;
    madj = unique(madj);
    madj = setdiff(madj, m);
    new_neigh{i} = madj;
    
    if exist('sdf_str', 'var')
        if(length(m) == 1)
            sdf_str2.sdf = [sdf_str2.sdf; sdf_str.sdf(m, :)];
            sdf_str2.sdf_norm = [sdf_str2.sdf_norm; sdf_str.sdf_norm(m, :)];
            sdf_str2.sdf_norm2 = [sdf_str2.sdf_norm2; sdf_str.sdf_norm2(m, :)];
            if(~isempty(find(sdf_str.flats == m)))
                patches_to_do = [patches_to_do i];
                sdf_str2.flats = [sdf_str2.flats i];
            end
        else
            
            patches_to_do = [patches_to_do i];
            sdf_str2.sdf = [sdf_str2.sdf; zeros(size(sdf_str.sdf(1,:)))];
            sdf_str2.sdf_norm = [sdf_str2.sdf_norm; zeros(size(sdf_str.sdf_norm(1,:)))];
            sdf_str2.sdf_norm2 = [sdf_str2.sdf_norm2; zeros(size(sdf_str.sdf_norm2(1,:)))];
            
        end
    end
end

if exist('sdf_str', 'var')
    ppoints = patch_subsample(info.points, info.normals, 2, patches2);
    sdf_str2 = patch_sdf(info.points, info.normals, ppoints, patches_to_do, info.outliers, idx2, 0, sdf_str2);
end

patch_adj2 = zeros(length(patches2));
ang_hist2 = zeros(length(patches2),length(patches2),4);

for i=1:length(patches2)
    nn = new_neigh{i};
    neigh = lookup(nn);
    neigh = unique(neigh);
    patch_adj2(i,neigh) = 1;
    
    m = merged{i};
    
    for j=1:length(m)
        for k=1:length(nn)
             tmp = ang_hist(m(j),nn(k),:);
             ang_hist2(i,lookup(nn(k)),:) = ang_hist2(i,lookup(nn(k)),:) + tmp;
        end
    end
end

patch_adj_c2 = adj_matrix_to_cell(patch_adj2);

end

