
%  Copyright (c) 2013
%      Oliver van Kaick <ovankaic@gmail.com>

function [ points, normals ] = mesh_to_point_cloud( vertices, faces )

    F = size(faces,1);

    points = zeros(F,3);
    normals = zeros(F,3);

    for i = 1:F
       points(i,:) = sum(vertices(faces(i,:),:)) / 3;

       vector1 = vertices(faces(i,2),:) - vertices(faces(i,1),:);
       vector2 = vertices(faces(i,3),:) - vertices(faces(i,2),:);

       normals(i,:) = cross(vector1, vector2);
       normals(i,:) = normals(i,:) / norm(normals(i,:));
    end

end

