
%  Copyright (c) 2013
%      Noa Fish <noafish@post.tau.ac.il>

% Subsample point cloud according to patches

function patch_points = patch_subsample(points, outliers, mode, patches)

    patch_points = cell(size(patches));
    
    % Subsample a number of points per patch
    for i = 1:length(patches)
        currp = patches{i};
        nump = length(currp);
        
        if(mode == 1)
            num_points = 10;
        else
            num_points = max(100, 0.1*nump);
        end
        
        psel = farthest_points_no_outliers(points, currp, outliers, num_points, []);
        patch_points{i} = currp(psel);
        
    end
    
end
