function [ radiuses ] = point_cloud_estimate_radiuses( points, normals )

%% find the p-closest distances to each point in the cloud
p = 11; % 10 not counting the closest point which is itself
[~, closestDistances] = knnsearch(points, points, 'K', p);

% estimate the radius of each splat, as average of its closest distances
radiuses = (sum(closestDistances, 2) / (p-1)) / 2; % the first distance is always zero
%radiuses = closestDistances(:,p) / 2;

end

