function show_points(points, clusters, noz)

    if ~exist('noz', 'var')
        noz = 0;
    end
    colors = clustering_to_coloring(clusters_to_clustering(clusters));

    points(:, 3) = max(points(:, 3)) - points(:, 3) + min(points(:, 3));
    points(:, 1) = max(points(:, 1)) - points(:, 1) + min(points(:, 1));
    fh = figure;
    hold on;
    nc = length(clusters);
    for i = 1:nc
        sel = clusters{i};
        if length(sel) > 0
            h = plot3(points(sel, 1), points(sel, 2), points(sel, 3), 'o');
            set(h, 'MarkerFaceColor', colors(sel(1), :));
            set(h, 'MarkerEdgeColor', colors(sel(1), :));
            %set(h, 'MarkerSize', 2);
            set(h, 'MarkerSize', 6);
            set(h, 'UserData', i);
            if length(sel) > 1
                avg = mean(points(sel, :));
            else
                avg = points(sel, :);
            end
            if noz
                z = max(points(sel, 3)) + 1;
                %text(avg(1), avg(2), z, num2str(i));
            else
                %text(avg(1), avg(2), avg(3), num2str(i));
            end
        end
    end

%    leg = {};
%    for i = 1:nc
%        leg{end+1} = ['Cluster ' num2str(i)];
%    end
%    legend(leg);

    dcm_obj = datacursormode(fh);
    set(dcm_obj,'UpdateFcn',@myfunction);
end


function output_txt = myfunction(obj, event_obj)
% http://www.mathworks.com/help/matlab/creating_plots/data-cursor-displaying-data-values-interactively.html
    % Display the position of the data cursor
    % obj          Currently not used (empty)
    % event_obj    Handle to event object
    % output_txt   Data cursor text string (string or cell array of strings).

    ob = get(event_obj, 'Target');
    index = get(ob, 'UserData');

    output_txt = {['Cluster: ',num2str(index)]};
end
